    module shared_data
    contains
      subroutine sort(n,arr)
      integer,parameter::M=7,NSTACK=50
      character(len=2000),dimension(n),intent(inout)::arr
      integer,intent(in)::n
      integer,dimension(NSTACK)::istack
      integer::i,ir,j,jstack,k,l
      character(len=2000)::a,temp
!     Sorts an array arr(1:n) into ascending numerical order using the Quicksort algorithm. n
!     is input; arr is replaced on output by its sorted rearrangement.
!     Parameters: M is the size of subarrays sorted by straight insertion and NSTACK is the required
!     auxiliary storage.
      jstack=0
      l=1
      ir=n
1     if(ir-l.lt.M)then
        do j=l+1,ir
          a=arr(j)
          do i=j-1,l,-1
            if (arr(i).le.a) goto 2
            arr(i+1)=arr(i)
          enddo
          i=l-1
2         arr(i+1)=a
        enddo
        if(jstack.eq.0)return
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      else
        k=(l+ir)/2
        temp=arr(k)
        arr(k)=arr(l+1)
        arr(l+1)=temp
        if(arr(l).gt.arr(ir))then
          temp=arr(l)
          arr(l)=arr(ir)
          arr(ir)=temp
        endif
        if(arr(l+1).gt.arr(ir))then
          temp=arr(l+1)
          arr(l+1)=arr(ir)
          arr(ir)=temp
        endif
        if(arr(l).gt.arr(l+1))then
          temp=arr(l)
          arr(l)=arr(l+1)
          arr(l+1)=temp
        endif
        i=l+1
        j=ir
        a=arr(l+1)
3       continue
        i=i+1
        if(arr(i).lt.a)goto 3
4       continue
        j=j-1
        if(arr(j).gt.a)goto 4
        if(j.lt.i)goto 5
        temp=arr(i)
        arr(i)=arr(j)
        arr(j)=temp
        goto 3
5       arr(l+1)=arr(j)
        arr(j)=a
        jstack=jstack+2
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      goto 1
      end subroutine
!     ****************************************************************************
!     ****************************************************************************
      subroutine indexx(n,arr,indx)
      integer n,indx(n),M,NSTACK
      integer arr(n)
      parameter (M=7,NSTACK=50)
!     Indexes an array arr(1:n), i.e., outputs the array indx(1:n) such that arr(indx(j))
!     is in ascending order for j = 1, 2, . . . , N . The input quantities n and arr are not changed.
      integer i,indxt,ir,itemp,j,jstack,k,l,istack(NSTACK)
      integer a
      do j=1,n
        indx(j)=j
      enddo
      jstack=0
      l=1
      ir=n
1     if(ir-l.lt.M)then
        do j=l+1,ir
          indxt=indx(j)
          a=arr(indxt)
          do i=j-1,l,-1
            if (arr(indx(i)).le.a) goto 2
            indx(i+1)=indx(i)
          enddo
          i=l-1
2         indx(i+1)=indxt
        enddo
        if (jstack.eq.0) return
        ir=istack(jstack)
        l=istack(jstack-1)
        jstack=jstack-2
      else
        k=(l+ir)/2
        itemp=indx(k)
        indx(k)=indx(l+1)
        indx(l+1)=itemp
        if (arr(indx(l)).gt.arr(indx(ir))) then
          itemp=indx(l)
          indx(l)=indx(ir)
          indx(ir)=itemp
        endif
        if (arr(indx(l+1)).gt.arr(indx(ir))) then
          itemp=indx(l+1)
          indx(l+1)=indx(ir)
          indx(ir)=itemp
        endif
        if(arr(indx(l)).gt.arr(indx(l+1)))then
          itemp=indx(l)
          indx(l)=indx(l+1)
          indx(l+1)=itemp
        endif
        i=l+1
        j=ir
        indxt=indx(l+1)
        a=arr(indxt)
3       continue
        i=i+1
        if(arr(indx(i)).lt.a)goto 3
4       continue
        j=j-1
        if (arr(indx(j)).gt.a) goto 4
        if(j.lt.i)goto 5
        itemp=indx(i)
        indx(i)=indx(j)
        indx(j)=itemp
        goto 3
5       indx(l+1)=indx(j)
        indx(j)=indxt
        jstack=jstack+2
        if(ir-i+1.ge.j-l)then
          istack(jstack)=ir
          istack(jstack-1)=i
          ir=j-1
        else
          istack(jstack)=j-1
          istack(jstack-1)=l
          l=i
        endif
      endif
      goto 1
      end subroutine
    end module
!   ****************************************************************************
!   ****************************************************************************
    program main
    use shared_data
    implicit none
    integer,parameter::dbl=selected_real_kind(p=13,r=200)
    integer,dimension(:),allocatable::edge1al,edge2al,posit,edge1,edge2,Mi,Mo,degi,dego,pi,po,pJimax,pJomax
    integer,dimension(:),allocatable::templist1,ilist,olist,polist,pilist,Jimax,Jomax,pJo,pJi,vecind,fdego,fdegi
    real(kind=dbl),dimension(:,:),allocatable::edgelist
    real(kind=dbl),dimension(:),allocatable::flux,templist2
    integer::initime,fintime,ierror,e1,e2,e3,maxR,i,nlink,maxi,maxo,pint,j,maxM,step,lisi,liso,nedge,k,l,newlinks,nodes,n,ns
    real(kind=dbl)::Ji,alpha,strength,aij,weight
    character(50)::file1,file2
    real::h,m,s

    initime=time()

    write(*,*)

    file1='Inputs/filterededgelist.net'
    file2='Inputs/contributions.dat'

    maxR=0
    open(100,file=trim(adjustl(file1)),status='OLD',action='READ',iostat=ierror)
    if (ierror.eq.0) then
      write(*,*)trim(adjustl(file1))//' read'
    else
      write(*,*)trim(adjustl(file1))//' not found. ABORTING!'
      stop
    endif
    do
      read(100,*,iostat=ierror)e1,e2,e3
      if (ierror.gt.0) then
        write(*,*)'Error at reading '//trim(adjustl(file1))
        stop
      else if (ierror.eq.-1) then
        exit
      endif
      if (e1.gt.maxR) maxR=e1
      if (e2.gt.maxR) maxR=e2
    enddo
    close(100)

    allocate(flux(10001:maxR+5000))
    flux=0
    open(100,file=trim(adjustl(file2)),status='OLD',action='READ',iostat=ierror)
    if (ierror.eq.0) then
      write(*,*)trim(adjustl(file2))//' read'
    else
      write(*,*)trim(adjustl(file2))//' not found. ABORTING!'
      stop
    endif
    do
      read(100,*,iostat=ierror)i,Ji
      if (ierror.gt.0) then
        write(*,*)'Error at reading '//trim(adjustl(file2))
        stop
      else if (ierror.eq.-1) then
        exit
      endif
      if (Ji.gt.0) then
        flux(i)=Ji
      else if (Ji.lt.0) then
        flux(i+5000)=-Ji
      endif
    enddo
    close(100)

    open(100,file=trim(adjustl(file1)),status='OLD',action='READ')
    allocate(edge1al(100000),edge2al(100000))
    edge1al=0
    edge2al=0  
    nlink=0
    do
      read(100,*,iostat=ierror)e1,e2,e3
      if (ierror.gt.0) then
        write(*,*)'Error at reading '//trim(adjustl(file1))
        stop
      else if (ierror.eq.-1) then
        exit
      endif
      if (e3.eq.0) then
        if (e1.gt.10000) then
          if (flux(e1).eq.0) cycle
          nlink=nlink+1
          edge1al(nlink)=e1
          edge2al(nlink)=e2
        else
          if (flux(e2).eq.0) cycle
          nlink=nlink+1
          edge1al(nlink)=e1
          edge2al(nlink)=e2
        endif
      else
        if (e1.gt.10000) then
          if (flux(e1).gt.0) then
            nlink=nlink+1
            edge1al(nlink)=e1
            edge2al(nlink)=e2
          endif
          if (flux(e1+5000).gt.0) then
            nlink=nlink+1
            edge1al(nlink)=e2
            edge2al(nlink)=e1+5000
          endif
        else
          if (flux(e2).gt.0) then
            nlink=nlink+1
            edge1al(nlink)=e1
            edge2al(nlink)=e2
          endif
          if (flux(e2+5000).gt.0) then
            nlink=nlink+1
            edge1al(nlink)=e2+5000
            edge2al(nlink)=e1
          endif
        endif
      endif
    enddo
    close(100)
    if (nlink.gt.10000) then
      write(*,*)'Reallocate edgelist vectors with size greater than 100000. Aborting'
      stop
    endif

!   Creating edge list

    allocate(edge1(nlink),edge2(nlink))
    edge1=edge1al
    edge2=edge2al
    deallocate(edge1al,edge2al)
    maxi=0
    maxo=0
    do i=1,nlink
      if (edge1(i).lt.10001) then
        if (edge1(i).gt.maxo) maxo=edge1(i)
      else
        if (edge2(i).gt.maxi) maxi=edge2(i)
      endif
    enddo
    maxM=maxi
    if (maxo.gt.maxM) maxM=maxo

!   Counting degrees and creating pointers

    allocate(dego(maxM),degi(maxM))
    dego=0
    degi=0
    do i=1,nlink
      if (edge1(i).lt.10001) then
        dego(edge1(i))=dego(edge1(i))+1
      else
        degi(edge2(i))=degi(edge2(i))+1
      endif
    enddo

    allocate(Mo(nlink),posit(nlink))
    posit=0
    call indexx(nlink,edge1,posit)
    Mo=0
    Mo=edge2(posit)
    allocate(po(maxM))
    po=0
    pint=1
    do i=1,maxM
      if (dego(i).gt.0) then
        po(i)=pint
        pint=pint+dego(i)
      endif
    enddo
    posit=0
    call indexx(nlink,edge2,posit)
    allocate(Mi(nlink))
    Mi=0
    Mi=edge1(posit)
    allocate(pi(maxM))
    pi=0
    pint=1
    do i=1,maxM
      if (degi(i).gt.0) then
        pi(i)=pint
        pint=pint+degi(i)
      endif
    enddo
    deallocate(edge1,edge2,posit)

    write(*,*)
    write(*,*)'Enter value of alpha'
    read(5,*)alpha

    write(*,*)
    write(*,*)'Confidence level=',1d0-alpha

!   Filtering network

    allocate(templist1(100000),templist2(100000),olist(100000),polist(100000))
    olist=0
    polist=0
    liso=0
    do i=1,maxM
      step=0
      templist1=0
      templist2=0
      if (dego(i).gt.0) then
        do j=po(i),po(i)-1+dego(i)
          step=step+1
          templist1(step)=Mo(j)
          templist2(step)=flux(Mo(j))
        enddo
        strength=sum(templist2)
        templist2=templist2/strength
        do j=1,step
          aij=-1
          if (dego(i).gt.1) aij=(1d0-templist2(j))**(dego(i)-1)
          if (aij.lt.alpha) then
            liso=liso+1
            olist(liso)=templist1(j)
            polist(liso)=i
          endif
        enddo
      endif
    enddo
    allocate(Jomax(liso),pJomax(liso))
    Jomax=olist
    pJomax=polist
    deallocate(olist,polist)

    allocate(ilist(100000),pilist(100000))
    ilist=0
    pilist=0
    lisi=0
    do i=1,maxM
      step=0
      templist1=0
      templist2=0
      if (degi(i).gt.0) then
        do j=pi(i),pi(i)-1+degi(i)
          step=step+1
          templist1(step)=Mi(j)
          templist2(step)=flux(Mi(j))
        enddo
        strength=sum(templist2)
        templist2=templist2/strength
        do j=1,step
          aij=-1
          if (degi(i).gt.1) aij=(1d0-templist2(j))**(degi(i)-1)
          if (aij.lt.alpha) then
            lisi=lisi+1
            ilist(lisi)=templist1(j)
            pilist(lisi)=i
          endif
        enddo
      endif
    enddo
    allocate(Jimax(lisi),pJimax(lisi))
    Jimax=ilist
    pJimax=pilist
    deallocate(ilist,pilist,degi,dego,po,pi,templist1,templist2,Mi,Mo)

!   Filtered network!

    allocate(degi(maxR+5000),dego(maxR+5000))
    degi=0
    dego=0
    do i=1,liso
      dego(pJomax(i))=dego(pJomax(i))+1
      degi(Jomax(i))=degi(Jomax(i))+1
    enddo
    do i=1,lisi
      dego(Jimax(i))=dego(Jimax(i))+1
      degi(pJimax(i))=degi(pJimax(i))+1
    enddo

    nedge=liso+lisi
    allocate(edge1(nedge),edge2(nedge))
    edge1=0
    edge2=0
    newlinks=0
    do i=1,liso
      newlinks=newlinks+1
      edge1(newlinks)=pJomax(i)
      edge2(newlinks)=Jomax(i)
    enddo
    do i=1,lisi
      newlinks=newlinks+1
      edge1(newlinks)=Jimax(i)
      edge2(newlinks)=pJimax(i)
    enddo
    deallocate(Jimax,pJimax,Jomax,pJomax)

    allocate(Mi(nedge),Mo(nedge),vecind(nedge))
    Mi=0
    Mo=0
    vecind=0
    call indexx(nedge,edge1,vecind)
    do i=1,nedge
      Mo(i)=edge2(vecind(i))
    enddo
    vecind=0
    call indexx(nedge,edge2,vecind)
    do i=1,nedge
      Mi(i)=edge1(vecind(i))
    enddo
    deallocate(vecind,edge1,edge2)

    allocate(pJo(maxM))
    pJo=0
    pint=1
    do i=1,maxM
      if (dego(i).gt.0) then
        pJo(i)=pint
        pint=pint+dego(i)
      endif
    enddo
    allocate(pJi(maxM))
    pJi=0
    pint=1
    do i=1,maxM
      if (degi(i).gt.0) then
        pJi(i)=pint
        pint=pint+degi(i)
      endif
    enddo

    allocate(fdegi(maxM),fdego(maxM),edgelist(100000,4))
    newlinks=0
    fdegi=0
    fdego=0
    edgelist=0
    do i=1,maxM-1
      do j=pJi(i),pJi(i)-1+degi(i)
        do k=i,maxM
          do l=pJo(k),pJo(k)-1+dego(k)
            if (Mi(j).eq.Mo(l)) then
              ns=1
              do n=1,newlinks
                if ((edgelist(n,1).eq.k).and.(edgelist(n,2).eq.i)) then
                  edgelist(n,3)=edgelist(n,3)+1
                  edgelist(n,4)=edgelist(n,4)+flux(Mi(j))   
                  ns=0
                endif
              enddo
              if (ns.eq.1) then 
                newlinks=newlinks+1
                edgelist(newlinks,1)=k
                edgelist(newlinks,2)=i
                edgelist(newlinks,3)=edgelist(newlinks,3)+1
                edgelist(newlinks,4)=edgelist(newlinks,4)+flux(Mi(j))                
                fdego(k)=fdego(k)+1
                fdegi(i)=fdegi(i)+1
              endif
            endif
          enddo
        enddo
      enddo
      do j=pJo(i),pJo(i)-1+dego(i)
        do k=i,maxM
          do l=pJi(k),pJi(k)-1+degi(k)
            if (Mo(j).eq.Mi(l)) then
              ns=1
              do n=1,newlinks
                if ((edgelist(n,1).eq.i).and.(edgelist(n,2).eq.k)) then
                  edgelist(n,3)=edgelist(n,3)+1
                  edgelist(n,4)=edgelist(n,4)+flux(Mo(j))
                  ns=0
                endif
              enddo
              if (ns.eq.1) then 
                newlinks=newlinks+1
                edgelist(newlinks,1)=i
                edgelist(newlinks,2)=k
                edgelist(newlinks,3)=edgelist(newlinks,3)+1
                edgelist(newlinks,4)=edgelist(newlinks,4)+flux(Mo(j))
                fdego(k)=fdego(k)+1
                fdegi(i)=fdegi(i)+1
              endif
            endif
          enddo
        enddo
      enddo
    enddo

    open(100,file='Outputs/1mpfilterededgelist.net',status='REPLACE',action='WRITE',iostat=ierror)
    if (ierror.ne.0) then
      write(*,*)'1mpfilterededgelist.net CANNOT BE CREATED! Aborting!'
      stop
    endif
    do i=1,newlinks
      write(100,*)int(edgelist(i,1)),int(edgelist(i,2)),int(edgelist(i,3)),edgelist(i,4)
    enddo
    close(100)

    nodes=0
    do i=1,maxM
      if (degi(i)+dego(i).gt.0) nodes=nodes+1
    enddo

    weight=0
    do i=1,newlinks
      weight=weight+edgelist(i,4)
    enddo 

    open(100,file='Outputs/statistics.dat',status='REPLACE',action='WRITE',iostat=ierror)
    if (ierror.ne.0) then
      write(*,*)'statistics.dat CANNOT BE CREATED! Aborting!'
      stop
    endif
    write(100,*)'alpha,links,nodes,weight'
    write(100,*)alpha,newlinks,nodes,weight
    close(100)
    write(*,*)alpha,newlinks,nodes,weight

    write(*,*)

    fintime=time()
    h=(fintime-initime)/3600.
    m=(h-int(h))*60.
    s=(m-int(m))*60.
    write(*,*)'Elapsed time=',int(h),'h',int(m),'min',int(s),'sec'

    end program
