    program main
    implicit none
    integer,parameter::dbl=selected_real_kind(p=13,r=200)
    integer,dimension(:),allocatable::label
    real(kind=dbl),dimension(:,:),allocatable::matrix,constraints
    real(kind=dbl),dimension(:),allocatable::results,obj
    character(50),dimension(:),allocatable::reactions
    integer::i,j,l,nM,ncol,ierror,nR,par
    real(kind=dbl)::a,b,maxi,mini,k
    character(20)::extra,extra2
    character(50)::variable2,file1,file2,file3
    character(20000)::variable1

    write(*,*)
    
    file1='Inputs/metabolites.dat'
    file2='Inputs/objconstraints.dat'
    file3='Inputs/edgelist.net'

    nM=0
    open(100,file=file1,status='OLD',iostat=ierror)
    if (ierror.eq.0) then
      write(*,*)'metabolites.dat read'
    else
      write(*,*)'metabolites.dat NOT FOUND. Aborting!'
      stop
    endif
    do
      read(100,'(a)',iostat=ierror)extra
      if (ierror.gt.0) then
        write(*,*)'Error at reading metabolites.dat'
        stop
      else if (ierror.eq.-1) then
        exit
      endif
      nM=nM+1
    enddo
    close(100)

    ncol=0
    nR=0
    open(100,file=file2,status='OLD',iostat=ierror)
    if (ierror.eq.0) then
      write(*,*)'objconstraints.dat read'
    else
      write(*,*)'objconstraints.dat NOT FOUND. Aborting!'
      stop
    endif	
    do
      read(100,*,iostat=ierror)i,j,k,a,b,variable2
      if (ierror.gt.0) then
        write(*,*)'Error at reading objconstraints.dat',i
        stop
      else if (ierror.eq.-1) then
        exit
      endif
      ncol=ncol+1
      if (j.gt.nR) nR=j
    enddo
    close(100)

    allocate(reactions(10001:nR),obj(ncol),label(ncol),constraints(ncol,2))
    reactions=''
    obj=0
    label=0
    constraints=0
    maxi=-1d30
    mini=1d30
    open(100,file=file2)
    do i=1,ncol
      read(100,*,iostat=ierror)l,j,k,a,b,variable2
      if (ierror.gt.0) then
        write(*,*)'Error at reading objconstraints.dat'
        stop
      endif
      reactions(j)=variable2
      obj(l)=k
      label(l)=j
      constraints(l,1)=a
      constraints(l,2)=b
      if (b.gt.maxi) maxi=b
      if (a.lt.mini) mini=a
    enddo	
    close(100)

    allocate(matrix(nM,ncol))
    matrix=0
    open(100,file=file3,status='OLD',iostat=ierror)
    if (ierror.eq.0) then
      write(*,*)'edgelist.net read'
    else
      write(*,*)'edgelist.net NOT FOUND. Aborting!'
      stop
    endif
    do
      read(100,*,iostat=ierror)i,j,l,a
      if (ierror.gt.0) then
        write(*,*)'Error at reading edgelist.net'
        stop
      else if (ierror.eq.-1) then
        exit
      endif
      if (j.gt.10000) then
        matrix(i,j-10000)=a
      else
        matrix(j,i-10000)=a
      endif
    enddo
    close(100)

    open(100,file='Outputs/toopt.lp',status='REPLACE',iostat=ierror)
    if (ierror.ne.0) then
      write(*,*)'ecoli.lp CANNOT BE CREATED. Aborting!'
      stop
    endif
    write(100,'(a)')'Maximize'
    variable1=''
    do i=1,ncol
      if (obj(i).ne.0) then
        extra=''
        write(extra,*)label(i)
        write(extra2,*)obj(i)
        variable1=trim(adjustl(variable1))//' +'//trim(adjustl(extra2))//' R_'//trim(adjustl(extra))
      endif
    enddo
    write(100,'(a)')' OBJ: '//trim(adjustl(variable1))
    write(100,'(a)')
    write(100,'(a)')'Subject to'
    do i=1,nM
      extra=''
      write(extra,*)i
      variable1='M_'//trim(adjustl(extra))//':'
      do j=1,ncol
        if (matrix(i,j).gt.0) then
          extra=''
          write(variable2,*)matrix(i,j)
          write(extra,*)label(j)
          variable1=trim(adjustl(variable1))//' +'//trim(adjustl(variable2))//' R_'//trim(adjustl(extra))
        endif
        if (matrix(i,j).lt.0) then
          extra=''
          write(variable2,*)matrix(i,j)
          write(extra,*)label(j)
          variable1=trim(adjustl(variable1))//' '//trim(adjustl(variable2))//' R_'//trim(adjustl(extra))
        endif
      enddo
      write(100,'(1x,a)')trim(adjustl(variable1))//' = 0'
    enddo
    write(100,'(a)')
    write(100,'(a)')'Bounds'
    do i=1,ncol
      if (obj(i).eq.1) then
        extra=''
        write(extra,*)label(i)
        write(100,*)constraints(i,1),'<= R_'//trim(adjustl(extra))//' <= ',constraints(i,2)
        cycle
      endif
      extra=''
      write(extra,*)label(i)
      if ((constraints(i,2).eq.maxi).and.(constraints(i,1).eq.mini)) then
        write(100,*)'-inf <= R_'//trim(adjustl(extra))//' <= +inf'
      else if ((constraints(i,2).eq.maxi).and.(constraints(i,1).ne.mini)) then
        write(100,*)constraints(i,1),'<= R_'//trim(adjustl(extra))//' <= +inf'
      else if ((constraints(i,2).ne.maxi).and.(constraints(i,1).eq.mini)) then
        write(100,*)'-inf <= R_'//trim(adjustl(extra))//' <=',constraints(i,2)
      else
        write(100,*)constraints(i,1),'<= R_'//trim(adjustl(extra))//' <=',constraints(i,2)
      endif
    enddo
    write(100,'(a)')
    write(100,'(a)')'End'
    close(100)
    close(101)

    write(*,*)
    write(*,*)'Calling glpsol...'
    write(*,*)

    call system('glpsol --nopresol --dual --xcheck --lp Outputs/toopt.lp -o Outputs/results.dat')

    allocate(results(10001:nR))
    results=0
    open(100,file='Outputs/results.dat',status='OLD',iostat=ierror)
    if (ierror.ne.0) then
      write(*,*)'results.dat NOT FOUND. Aborting!'
      stop
    endif
    par=0
    do
      if (par.eq.0) then
        read(100,'(a)',iostat=ierror)variable1
      else
        read(100,*,iostat=ierror)i,extra,variable2,a
      endif
      if (ierror.gt.0) then
        write(*,*)'Error at reading results.dat'
        stop
      endif
      if (par.eq.0) then
        if (index(variable1,'Column name').ne.0) then
          par=1
          read(100,'(a)',iostat=ierror)variable1
          if (ierror.gt.0) then
            write(*,*)'Error at reading results.dat'
            stop
            cycle
          endif
        endif
        cycle
      endif
      extra=extra(3:)
      read(extra,*)j
      results(j)=a
      if (i.eq.ncol) exit
    enddo
    close(100)
    write(*,*)

    open(100,file='Outputs/finalresults.dat',status='REPLACE',iostat=ierror)
    if (ierror.ne.0) then
      write(*,*)'finalresults.dat CANNOT BE CREATED. Aborting!'
      stop
    endif
    do i=10001,nR
      if (obj(i-10000).ne.0) write(*,*)trim(adjustl(reactions(i))),results(i)
      write(100,*)i,trim(adjustl(reactions(i))),results(i)
    enddo
    close(100)

    write(*,*)

    end
